From c754e51b2613ceef6d96a72eddb177d2f5810e6e Mon Sep 17 00:00:00 2001
From: Ashutosh Bapat <ashutosh.bapat.oss@gmail.com>
Date: Wed, 1 Jan 2025 14:02:28 +0530
Subject: [PATCH v10 08/12] Document fixes

Assorted grammar and typo fixes.

Author: Junwang Zhou
Reviewed with minor adjustments by: Ashutosh Bapat
---
 doc/src/sgml/information_schema.sgml        | 18 +++++++++---------
 doc/src/sgml/ref/alter_property_graph.sgml  |  2 +-
 doc/src/sgml/ref/create_property_graph.sgml |  2 +-
 doc/src/sgml/ref/drop_property_graph.sgml   |  2 +-
 4 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/doc/src/sgml/information_schema.sgml b/doc/src/sgml/information_schema.sgml
index e6561543f62..59b956e5807 100644
--- a/doc/src/sgml/information_schema.sgml
+++ b/doc/src/sgml/information_schema.sgml
@@ -4227,7 +4227,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -4346,7 +4346,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -4430,7 +4430,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -4505,7 +4505,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -4589,7 +4589,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -4700,7 +4700,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -4774,7 +4774,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -4839,7 +4839,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
 
@@ -5255,7 +5255,7 @@ ORDER BY c.ordinal_position;
        <structfield>property_graph_name</structfield> <type>sql_identifier</type>
       </para>
       <para>
-       Name of the property_graph
+       Name of the property graph
       </para></entry>
      </row>
     </tbody>
diff --git a/doc/src/sgml/ref/alter_property_graph.sgml b/doc/src/sgml/ref/alter_property_graph.sgml
index 604c5180117..4ae53deb092 100644
--- a/doc/src/sgml/ref/alter_property_graph.sgml
+++ b/doc/src/sgml/ref/alter_property_graph.sgml
@@ -99,7 +99,7 @@ ALTER PROPERTY GRAPH [ IF EXISTS ] <replaceable class="parameter">name</replacea
      <term><literal>ALTER {VERTEX|NODE|EDGE|RELATIONSHIP} TABLE ... DROP LABEL</literal></term>
      <listitem>
       <para>
-       This form removes a new label from an existing vertex or edge table.
+       This form removes a label from an existing vertex or edge table.
       </para>
      </listitem>
     </varlistentry>
diff --git a/doc/src/sgml/ref/create_property_graph.sgml b/doc/src/sgml/ref/create_property_graph.sgml
index ae301b52e0a..76bfef317af 100644
--- a/doc/src/sgml/ref/create_property_graph.sgml
+++ b/doc/src/sgml/ref/create_property_graph.sgml
@@ -151,7 +151,7 @@ CREATE [ TEMP | TEMPORARY ] PROPERTY GRAPH <replaceable class="parameter">name</
     <listitem>
      <para>
       The vertex tables that the edge table is linked to.  These refer to the
-      aliases of a the vertex table.
+      aliases of the source and destination vertex tables respectively.
      </para>
     </listitem>
    </varlistentry>
diff --git a/doc/src/sgml/ref/drop_property_graph.sgml b/doc/src/sgml/ref/drop_property_graph.sgml
index 31cb77a2af1..e16de5507b1 100644
--- a/doc/src/sgml/ref/drop_property_graph.sgml
+++ b/doc/src/sgml/ref/drop_property_graph.sgml
@@ -96,7 +96,7 @@ DROP PROPERTY GRAPH g1;
    <command>DROP PROPERTY GRAPH</command> conforms to ISO/IEC 9075-16
    (SQL/PGQ), except that the standard only allows one property graph to be
    dropped per command, and apart from the <literal>IF EXISTS</literal>
-   option, which is a <productname>PostgreSQL</productname> extension..
+   option, which is a <productname>PostgreSQL</productname> extension.
   </para>
  </refsect1>
 
-- 
2.39.5